# -*- coding: utf-8 -*-
#
# File: Classification.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.Relations.field import RelationField
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName

##/code-section module-header

schema = Schema((

    RelationField(
        name='people',
        widget=ReferenceBrowserWidget(
            restrict_browsing_to_startup_directory="False",
            label='People',
            label_msgid='FacultyStaffDirectory_label_people',
            i18n_domain='FacultyStaffDirectory',
        ),
        multiValued=1,
        relationship='classifications_people'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Classification_schema = BaseSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
#ArchGenXML won't let us do this.
Classification_schema['people'].allowed_types=('Person')
##/code-section after-schema

class Classification(BaseContent, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Classification'

    meta_type = 'Classification'
    portal_type = 'Classification'
    allowed_content_types = [] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    content_icon = 'folder_icon.gif'
    immediate_view = 'classification_standard_view'
    default_view = 'classification_standard_view'
    suppl_views = ('classification_standard_view', 'classification_tabular_view')
    typeDescription = "A grouping of associated people"
    typeDescMsgId = 'description_edit_classification'


    actions =  (


       {'action': "string:${object_url}",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("permissions.ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


    )

    _at_rename_after_creation = True

    schema = Classification_schema

    ##code-section class-header #fill in your manual code here
    aliases = {
        '(Default)' : '(dynamic view)',
        'view' : '(selected layout)',
        'index.html' : '(dynamic view)',
        'edit' : 'base_edit',
        'sharing': 'folder_localrole_form'
    }


    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declareProtected(View, 'getPeople')
    def getPeople(self):
        """ Return a list of people in this classification, filtered by the current context
        """

        #There *has* to be a better way to do this...
        localPeople = self.getReferences()

        #Return the intersection of people referenced to this classification and people within/referenced to the parent
        return list(set(localPeople) & set(self.aq_parent.getPeople()))

    security.declareProtected(View, 'getSortedPeople')
    def getSortedPeople(self):
        """ Return a list of people, sorted by SortableName
        """
        people = self.getPeople()
        pList = [(people[i].getSortableName(), i, people[i]) for i in xrange(len(people))]
        pList.sort()
        return [tup[-1] for tup in pList]



registerType(Classification, PROJECTNAME)
# end of class Classification

##code-section module-footer #fill in your manual code here
##/code-section module-footer



