# -*- coding: utf-8 -*-
#
# File: Committee.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.Archetypes.ReferenceEngine import ContentReferenceCreator
from Products.Relations.field import RelationField
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

    TextField(
        name='description',
        widget=TextAreaWidget(
            label='Description',
            label_msgid='FacultyStaffDirectory_label_description',
            i18n_domain='FacultyStaffDirectory',
        ),
        accessor="Description",
        searchable=True
    ),

    TextField(
        name='text',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label="Body Text",
            label_msgid='FacultyStaffDirectory_label_text',
            i18n_domain='FacultyStaffDirectory',
        ),
        default_output_type="text/x-html-safe",
        searchable=True,
        validators=('isTidyHtmlWithCleanup',)
    ),

    RelationField(
        name='members',
        widget=ReferenceBrowserWidget(
            restrict_browsing_to_startup_directory="False",
            label='Members',
            label_msgid='FacultyStaffDirectory_label_members',
            i18n_domain='FacultyStaffDirectory',
        ),
        multiValued=True,
        relationship='CommitteeMembership'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Committee_schema = OrderedBaseFolderSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
#ArchGenXML won't let us do this for some reason.
Committee_schema['members'].allowed_types=('Person')

##/code-section after-schema

class Committee(OrderedBaseFolder, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(OrderedBaseFolder,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Committee'

    meta_type = 'Committee'
    portal_type = 'Committee'
    allowed_content_types = ['Document', 'File', 'Image'] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    content_icon = 'group.png'
    immediate_view = 'committee_view'
    default_view = 'committee_view'
    suppl_views = ()
    typeDescription = "A simple page describing a committee with the associated committee members."
    typeDescMsgId = 'description_edit_committee'


    actions =  (


       {'action': "string:${object_url}/",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


    )

    _at_rename_after_creation = True

    schema = Committee_schema

    ##code-section class-header #fill in your manual code here
    aliases = {
        '(Default)' : '(dynamic view)',
        'view' : '(selected layout)',
        'index.html' : '(dynamic view)',
        'edit' : 'pre_edit_setup',
        'sharing': 'folder_localrole_form'
    }

    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declareProtected(ModifyPortalContent, 'pre_edit_setup')
    def pre_edit_setup(self):
        """ I hate myself for doing this, but until we can get
            ReferenceBrowserWidget to accept proper relative paths (../../) or
            functions, this is what we get.  Can't do it on __init__ since it
            doesn't recognize any of the portal tools for some reason.
        """
        urlTool = getToolByName(self, 'portal_url')
        #Set the startup directory for the members field to the root of the FacultyStaffDirectory
        self.schema['members'].widget.startup_directory = '/%s/' % urlTool.getRelativeContentURL(self.getDirectoryRoot())
        return self.base_edit()

    def getMembershipInformation(self, person):
        """ Get the committee membership information for a specific person
        """
        refCatalog = getToolByName(self, 'reference_catalog')
        refs = refCatalog.getReferences(self, 'CommitteeMembership', person)

        if not refs:
            return None
        else:
            return refs[0].getContentObject()

    security.declareProtected(View, 'getPeople')
    def getPeople(self):
        """ Return the people in this committee.
            Mainly for context-sensitive classifications
        """
        return self.getMembers()



registerType(Committee, PROJECTNAME)
# end of class Committee

##code-section module-footer #fill in your manual code here
##/code-section module-footer



