# -*- coding: utf-8 -*-
#
# File: Specialty.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.Archetypes.ReferenceEngine import ContentReferenceCreator
from Products.Relations.field import RelationField
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget

##/code-section module-header

schema = Schema((

    TextField(
        name='description',
        widget=TextAreaWidget(
            label='Description',
            label_msgid='FacultyStaffDirectory_label_description',
            i18n_domain='FacultyStaffDirectory',
        ),
        accessor="Description",
        searchable=True
    ),

    TextField(
        name='text',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label="Body Text",
            label_msgid='FacultyStaffDirectory_label_text',
            i18n_domain='FacultyStaffDirectory',
        ),
        default_output_type="text/x-html-safe",
        searchable=True,
        validators=('isTidyHtmlWithCleanup',)
    ),

    RelationField(
        name='people',
        widget=ReferenceBrowserWidget(
            label='People',
            label_msgid='FacultyStaffDirectory_label_people',
            i18n_domain='FacultyStaffDirectory',
        ),
        multiValued=True,
        relationship='SpecialtyInformation'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Specialty_schema = BaseFolderSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
#ArchGenXML won't let us do this for some reason
Specialty_schema['people'].allowed_types=('Person')

##/code-section after-schema

class Specialty(BaseFolder, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Specialty'

    meta_type = 'Specialty'
    portal_type = 'Specialty'
    allowed_content_types = ['Specialty'] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'Specialty.gif'
    immediate_view = 'specialty_standard_view'
    default_view = 'specialty_standard_view'
    suppl_views = ('specialty_standard_view', 'specialty_tabular_view')
    typeDescription = "Specialty"
    typeDescMsgId = 'description_edit_specialty'


    actions =  (


       {'action': "string:${object_url}",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


    )

    _at_rename_after_creation = True

    schema = Specialty_schema

    ##code-section class-header #fill in your manual code here
    # Rig it so the selected view actually takes effect:
    aliases = {
        '(Default)': '(dynamic view)',
        'view': '(selected layout)',
        'index.html': '(dynamic view)',
        'edit': 'pre_edit_setup',
        'sharing': 'folder_localrole_form'
    }
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declareProtected(View, 'getSpecialtyInformation')
    def getSpecialtyInformation(self, person):
        """
        Get the specialty information for a specific person
        """
        refCatalog = getToolByName(self, 'reference_catalog')
        refs = refCatalog.getReferences(self, 'SpecialtyInformation', person)

        if not refs:
            return None
        else:
            return refs[0].getContentObject()

    security.declareProtected(ModifyPortalContent, 'pre_edit_setup')
    def pre_edit_setup(self):
        """ I hate myself for doing this, but until we can get
            ReferenceBrowserWidget to accept proper relative paths (../../) or
            functions, this is what we get.  Can't do it on __init__ since it
            doesn't recognize any of the portal tools for some reason.
        """
        #Set the startup directory for the members field to the root of the FacultyStaffDirectory
        urlTool = getToolByName(self, 'portal_url')
        self.schema['people'].widget.startup_directory = '/%s/' % urlTool.getRelativeContentURL(self.getDirectoryRoot())
        return self.base_edit()



registerType(Specialty, PROJECTNAME)
# end of class Specialty

##code-section module-footer #fill in your manual code here
##/code-section module-footer



